package net.cattaka.rdbassistant.gui.script;

import java.awt.Component;

import javax.swing.JTabbedPane;

import net.cattaka.rdbassistant.bean.RdbaSingletonBundle;
import net.cattaka.rdbassistant.config.RdbaConfig;
import net.cattaka.rdbassistant.core.RdbaConnection;
import net.cattaka.rdbassistant.gui.RdbaGuiInterface;
import net.cattaka.rdbassistant.gui.RdbaMessage;
import net.cattaka.util.MessageBundle;

public class RdbaScriptAssistTabbedPanel extends JTabbedPane implements RdbaGuiInterface {
	private static final long serialVersionUID = 1L;
	private RdbaGuiInterface parentComponent;
	private RdbaScriptAccessPanel rdbaScriptAccessPanel;
	
	public RdbaScriptAssistTabbedPanel(RdbaGuiInterface parentComponent) {
		this.parentComponent = parentComponent;
		makeLayout();
	}
	
	private void makeLayout() {
		this.rdbaScriptAccessPanel = new RdbaScriptAccessPanel(this);
		
		this.addTab(MessageBundle.getMessage("script_list"), this.rdbaScriptAccessPanel);
	}

	public void setRdbaConnection(RdbaConnection rdbaConnection) {
		// 無し
	}

	/** {@link RdbaGuiInterface} */
	public void doGuiLayout() {
		// 無し
	}

	/** {@link RdbaGuiInterface} */
	public RdbaConfig getRdbaConfig() {
		return parentComponent.getRdbaConfig();
	}

	/** {@link RdbaGuiInterface} */
	public RdbaSingletonBundle getRdbaSingletonBundle() {
		return parentComponent.getRdbaSingletonBundle();
	}

	/** {@link RdbaGuiInterface} */
	public void relayRdbaMessage(RdbaMessage rdbaMessage) {
		Component comp = this.getSelectedComponent();
		if (comp != null && comp instanceof RdbaGuiInterface) {
			((RdbaGuiInterface)comp).relayRdbaMessage(rdbaMessage);
		}
	}

	/** {@link RdbaGuiInterface} */
	public void reloadRdbaConfig() {
		this.rdbaScriptAccessPanel.reloadRdbaConfig();
	}

	/** {@link RdbaGuiInterface} */
	public void sendRdbaMessage(RdbaMessage rdbaMessage) {
		parentComponent.sendRdbaMessage(rdbaMessage);
	}

	/** {@link RdbaScriptSelectPanel} {@link RdbaScriptAccessPanel} */
	public void setRdbaScriptEditorTabbedPanel(RdbaScriptEditorTabbedPanel rdbaScriptEditorPanel) {
		rdbaScriptAccessPanel.setRdbaScriptEditorTabbedPanel(rdbaScriptEditorPanel);
	}
}
