package net.cattaka.rdbassistant.gui.table;

import java.awt.Font;
import java.awt.FontMetrics;
import javax.swing.table.TableColumn;

import net.cattaka.rdbassistant.RdbaConstants;
import net.cattaka.rdbassistant.gui.RdbaTextInterface;
import net.cattaka.swing.table.StdTable;

public class JTableForDisplay extends StdTable {
	private static final long serialVersionUID = 1L;
	private JPopupMenuForColumnList popupMenu;
	private int fontWidth = 10;

	public JTableForDisplay() {
		super();
		this.popupMenu = new JPopupMenuForColumnList(false);
		this.popupMenu.createMenuItems();
		initialize();
	}

	public JTableForDisplay(JPopupMenuForColumnList popupMenu) {
		super();
		this.popupMenu = popupMenu;
		initialize();
	}

	private void initialize() {
		this.popupMenu.install(this);
	}

	@Override
	public boolean isCellEditable(int row, int column) {
		return false;
	}

	@Override
	public void setFont(Font font) {
		super.setFont(font);
		this.getTableHeader().setFont(font);

		// フォントの標準幅を計算
		FontMetrics fm = this.getFontMetrics(font);
		String str = RdbaConstants.STRING_FOR_MESURE_WIDTH;
		this.fontWidth = fm.stringWidth(str) / str.length();
	}

	public void setResultSetTableModel(ResultSetTableModel dataModel) {
		super.setModel(dataModel);
		int[] columnCharacters = dataModel.getColumnCharacters();
		if (columnCharacters != null) {
			for (int i = 0; i < columnCharacters.length; i++) {
				TableColumn tableColmun = this.columnModel.getColumn(i);
				tableColmun
						.setPreferredWidth(this.fontWidth
								* (columnCharacters[i] + RdbaConstants.TABLE_MARGIN_CHARS));
			}
		}
	}

	public RdbaTextInterface getRdbaTextInterface() {
		return this.popupMenu.getRdbaTextInterface();
	}

	public void setRdbaTextInterface(RdbaTextInterface rdbaTextInterface) {
		this.popupMenu.setRdbaTextInterface(rdbaTextInterface);
		this.popupMenu.setMenuItemVisible(rdbaTextInterface != null);
	}
}
