package net.cattaka.rdbassistant.jspf.core.bean;

import java.sql.Connection;
import java.sql.DatabaseMetaData;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.List;

public class DatabaseInfo {
	public DatabaseMetaData databaseMetaData;
	public String name;
	private List<TableInfo> tableInfoList = null;

	public DatabaseInfo(DatabaseMetaData databaseMetaData, String name) {
		this.databaseMetaData = databaseMetaData;
		this.name = name;
	}

	private void createTableInfoList() throws SQLException {
		Connection connection = databaseMetaData.getConnection();
		ResultSet rs = null;
		try {
			rs = databaseMetaData.getTables(connection.getCatalog(), this.name, "%", null);
			this.tableInfoList = new ArrayList<TableInfo>();
			
			while(rs.next()) {
				String tableName = "";
				tableName = rs.getString("TABLE_NAME");
				TableInfo TableInfo = new TableInfo(this, databaseMetaData, tableName);
				this.tableInfoList.add(TableInfo);
			}
		} finally {
			if (rs != null) {
				rs.close();
			}
		}
	}

	public TableInfo getTableInfo(String tableName) throws SQLException {
		TableInfo result = null;
		List<TableInfo> til = getTableInfoList();
		for (TableInfo ti : til) {
			if (ti.getName().equals(tableName)) {
				result = ti;
				break;
			}
		}
		return result;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}
	

	public List<TableInfo> getTableInfoList() throws SQLException {
		if (tableInfoList == null) {
			this.createTableInfoList();
		}
		return tableInfoList;
	}
}
