package net.cattaka.rdbassistant.jspf.standard;

import java.io.PrintWriter;
import java.sql.SQLException;

import net.cattaka.rdbassistant.jspf.JspfConstants;
import net.cattaka.rdbassistant.jspf.core.JspfBase;
import net.cattaka.util.MessageBundle;

public class JspfBaseCreateSelectSql extends JspfBase {

	public JspfBaseCreateSelectSql() {
		this.setName(JspfConstants.JSPF_NAME_CREATE_SELECT_SQL);
		this.setDisplayName(MessageBundle.getMessage("create_select_sql"));
	}
	
	@Override
	public void runJspf(PrintWriter out) throws SQLException {
		out.println("SELECT");
		boolean firstFlag = true;
		for (String columnName:selectionInfo.getColumns()) {
			if (firstFlag) {
				firstFlag = false;
			} else {
				out.print(",\n");
			}
			out.print("\t"+columnName);
		}
		out.print("\n");
		out.println("FROM");
		
		firstFlag = true;
		for (String tableName:selectionInfo.getTables()) {
			if (firstFlag) {
				firstFlag = false;
			} else {
				out.print(",\n");
			}
			out.print("\t"+tableName);
		}
		out.print("\n");
	}
}
