package net.cattaka.rdbassistant.sql;

import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.text.NumberFormat;

public class BigDecimalColumnConverter implements ColumnConverter {
	private int integerDigits;
	private int fractionDigits;
	private NumberFormat numberFormat;
	
	public BigDecimalColumnConverter(int precision, int scale) {
		super();
		this.integerDigits = (precision > scale) ? precision - scale : 0;
		this.fractionDigits = (scale > 0) ? scale : 0;
		numberFormat = new DecimalFormat();
		numberFormat.setGroupingUsed(false);
		numberFormat.setMaximumIntegerDigits(integerDigits);
		numberFormat.setMaximumFractionDigits(fractionDigits);
//		numberFormat.setMinimumIntegerDigits(integerDigits);
		numberFormat.setMinimumFractionDigits(fractionDigits);
	}

	public Class<?> getInClass() {
		return BigDecimal.class;
	}

	public Class<?> getOutClass() {
//		return String.class;
		return BigDecimal.class;
	}
	
	public int getColumnMaxCharacters() {
		return integerDigits + fractionDigits;
	}

	public Object reverseConvert(Object arg) throws ConvertException {
		return arg;
	}

	public Object convert(Object arg) throws ConvertException {
		if (arg != null) {
			if (arg instanceof BigDecimal) {
				return ((BigDecimal)arg).setScale(this.fractionDigits);
			} else {
				throw new ConvertException();
			}
		} else {
			return null;
		}
	}

	public boolean isAvalConvert() {
		return true;
	}
	
	public boolean isAvalReverseConvert() {
		return true;
	}
}
